package org.zhouw.stps.monitor;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.Hashtable;

public class CheckpointLogItem extends LogItem {

	public CheckpointLogItem()
	{}
	public long totalLatency;
	public long timestamp;
	public long copyLatency;
	public long flushLatency;
	
	/**
	 * in MB
	 */
	public long freeMemoryBefore;
	public long freeMemoryAfter;
	public long totalMemoryBefore;
	public long totalMemoryAfter;
	
	public void fillFied(String[] paras)
	{
		if(paras.length<2)
			return;
		if(paras[0].compareTo("totalLatency")==0)
			this.totalLatency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("timestamp")==0)
			this.timestamp=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("copyLatency")==0)
			this.copyLatency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("flushLatency")==0)
			this.flushLatency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("freeMemoryBefore")==0)
			this.freeMemoryBefore=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("freeMemoryAfter")==0)
			this.freeMemoryAfter=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("totalMemoryBefore")==0)
			this.totalMemoryBefore=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("totalMemoryAfter")==0)
			this.totalMemoryAfter=Long.valueOf(paras[1]);
	}
	
	@Override
	public String writeToString() {
		String result="{\n";
		result+="totalLatency="+totalLatency+"\n";
		result+="timestamp="+timestamp+"\n";
		result+="copyLatency="+copyLatency+"\n";
		result+="flushLatency="+flushLatency+"\n";
		result+="freeMemoryBefore="+freeMemoryBefore+"\n";
		result+="freeMemoryAfter="+freeMemoryAfter+"\n";
		result+="totalMemoryBefore="+totalMemoryBefore+"\n";
		result+="totalMemoryAfter="+totalMemoryAfter+"\n";
		result+="}";
		return result;
	}

	public CheckpointLogItem(long totalLatency, long timestamp,
			long copyLatency, long flushLatency, long freeMemoryBefore,
			long freeMemoryAfter, long totalMemoryBefore, long totalMemoryAfter) 
	{
		super();
		this.totalLatency = totalLatency;
		this.timestamp = timestamp;
		this.copyLatency = copyLatency;
		this.flushLatency = flushLatency;
		this.freeMemoryBefore = freeMemoryBefore;
		this.freeMemoryAfter = freeMemoryAfter;
		this.totalMemoryAfter=totalMemoryAfter;
		this.totalMemoryBefore=totalMemoryBefore;
	}

}
