package org.zhouw.stps.monitor;

import org.zhouw.stps.conf.NodeConfig;
import org.zhouw.stps.conf.SystemConfigure;

public class FinalResultReduce {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if(args.length<3)
			return;
		LogReducer reducer=new LogReducer(args[0],args[1],args[2]);
		
		SystemConfigure sysConf=new SystemConfigure(args[2]);

			if(sysConf.doClientTransactionLog)
				{
				reducer.reduceClientTransactionLog();
				}
			if(sysConf.doDSLog)
				{
				reducer.reduceDataServiceLog();
				}
			if(sysConf.doIdServiceLog)
				reducer.reduceIDServiceLog();
			if(sysConf.dotpNodeLog)
				{
				reducer.reduceTPNodeLog();
				}
			if(sysConf.docheckPointLog)
				{
				reducer.reduceCheckPointLog();
				}
			if(sysConf.doloadDataLog)
				reducer.reduceLoadDataLog();

	}

}
