import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.components.RWGTMtoRWGTM_CreateBackupTCMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransCoodinatorMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.tp.*;
import org.zhouw.stps.*;

public class DoAddBackupTCService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		long id=-1;
		InputStream in;
		try {
			in = req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("DoAddBackupTC receive empty input, abort execution");
				return;
				}
			TransCoodinatorMsg msg=TransCoodinatorMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct TransCoodinatorMsg object failed with input content, abort execution");
				return;
				}
			//Transaction t=new Transaction(msg.getTran());
//			id=msg.getID();
//			TransCoodinator tc=new TransCoodinator(msg);
//			GlobalPara.rwComp.requestAddBackupTC(tc);
		} catch (IOException e) {
			e.printStackTrace();
			//failure during addTC, remove the added TC
			GlobalPara.logger.warning("Error when adding backup, delete the backup TC " + id);
//			if(id!=-1)
//				GlobalTransManager.removeBackupTC(id);
		}
	}

}
