import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.tp.UpdatesOfST;
import org.zhouw.stps.*;

public class DoRemoveBackupService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null){
				GlobalPara.logger.warning("DoRemoveBackupService receive empty input, abort execution");
				return;
			}
			UpdateOnDataRowMsg msg=UpdateOnDataRowMsg.parseFrom(in);
			if(msg==null){
				GlobalPara.logger.warning("Consturct UpdateOnDataRowMsg object failed with input content, abort execution");
				return;
			}
			UpdatesOfST data=new UpdatesOfST(msg);
			MsgBroker.cleanupInputStream(in);
			GlobalPara.ltmComp.doRemoveBackup(data);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
