import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public abstract class ManagedHttpServlet extends HttpServlet {

	public void doGet(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {
//	 long start=System.currentTimeMillis();
	  process(req,res);
//	  long end=System.currentTimeMillis();
//	  long duration=end-start;
	 // System.out.println(duration+"ms  for "+this.getClass().getSimpleName());
	}

	public void doPost(HttpServletRequest req, HttpServletResponse res)
	throws IOException, ServletException {
	//	long start=System.currentTimeMillis();
		process(req,res);
//		long end=System.currentTimeMillis();
//		long duration=end-start;
		//System.out.println(duration+"ms  for "+this.getClass().getSimpleName());
	}
	
	public abstract void process(HttpServletRequest req, HttpServletResponse res);

}
