import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.membership.msg.MembershipMsg.SendOnGoingTranRecoveryFinishToCoordinatorMsg;


public class ReceiveCommitRecoveredUpdatesCompleteToCoordinatorService extends
		ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		InputStream in;
		OutputStream output;
		try {
			in=req.getInputStream();
		
			if(in!=null)
			{
				SendOnGoingTranRecoveryFinishToCoordinatorMsg msg=SendOnGoingTranRecoveryFinishToCoordinatorMsg.parseFrom(in);
				int srcID=msg.getSrcID();
				GlobalPara.memberComp.reportRemoteUpdateCommitComplete(srcID);
			}
		} catch (IOException e) {
		e.printStackTrace();
		}

	}

}
