import java.io.IOException;
import java.io.OutputStream;
import java.util.concurrent.TimeUnit;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.tp.DTMsg;
import org.zhouw.stps.tp.GlobalTransManager;


public class ReportRestartService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		String ts = req.getParameter("timestamp");
	    String strGID = req.getParameter("GID");
	    String strId = req.getParameter("id");

	    if(ts==null||strGID==null||strId==null)
	    	{
	    	GlobalPara.logger.warning("Service receive empty input of timestamp, abort execution");
			return;
	    	}
	    //;GlobalPara.logger.info(ts+" : "+strGID + " : " + strId );
	    long  timestamp=Long.valueOf(ts);
	    long GID=Long.valueOf(strGID);
	    int id=Integer.valueOf(strId);
		
		DTMsg msg=new DTMsg(DTMsg.MSGTYPE.REPORTRESTART, id, timestamp, GID);
		GlobalPara.rwComp.reportRestart(msg);
	}

}
