import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROGlobalTM;
import org.zhouw.stps.rotran.Vote;
import org.zhouw.stps.rotran.ROTranMsg.ROTranResultMsg;
import org.zhouw.stps.rotran.ROTranMsg.ROTransactionMsg;


public class ReturnROTranResultToClient extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		InputStream in;
		try {
			in = req.getInputStream();
			if(in==null)
			{
				GlobalPara.logger.warning("Receive empty input, stop execution");
				return;
			}
			ROTranResultMsg msg=ROTranResultMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct ROTransactionMsg object failed with input content, abort execution");
				return;
				}
			//MsgBroker.cleanupInputStream(in);
			if(GlobalPara.clientComp!=null)
				GlobalPara.clientComp.submitROTranResult(msg);
			else
				GlobalPara.logger.warning("[Error]On clinet " + GlobalPara.sysConf.localNodeID+", its clientComp is null");
			//TransExecutor.returnROTranResult(msg);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}

	}

}
