import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.msg.MsgUtil;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STGMsg;
import org.zhouw.stps.tp.TPNode;
import org.zhouw.stps.rotran.ROTranMsg.*;
import org.zhouw.stps.rotran.*;

public class SubmitROTransaction extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("SubmitROTransaction receive empty input, abort execution");
				return;
				}
			SubROTranGroupMsg msg=SubROTranGroupMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct SubROTranGroupMsg object failed with input content, abort execution");
				return;
				}
			GlobalPara.ltmComp.submitROTran(msg);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
