import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.msg.SubTransactionGroupProtos.STGMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.msg.*;
import org.zhouw.stps.tp.*;

import org.zhouw.stps.*;

public class SubmitSTGService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("SubmitSTGService receive empty input, abort execution");
				return;
				}
			STGMsg msg=STGMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct STGMsg object failed with input content, abort execution");
				return;
				}
			SubTransactionGroup stg=new SubTransactionGroup(msg);
			GlobalPara.ltmComp.submitSTG(stg);
			MsgBroker.cleanupInputStream(in);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
