import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Random;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

import javax.servlet.ServletException;
import javax.servlet.ServletInputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.testFinaLoad;
import org.zhouw.stps.app.tpcw.Cart;
import org.zhouw.stps.app.tpcw.IDService;
import org.zhouw.stps.app.tpcw.TPCW_dataservice;
import org.zhouw.stps.conf.NodeMapping;
import org.zhouw.stps.app.tpcw.*;
import org.zhouw.stps.tp.*;;

public class TestService extends HttpServlet {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private static final long warmupInterval = 300000L;

	private static Random ran=new Random();
	
	
	public void doGet(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {
		
	  ExecutorService clientExecutor= Executors.newFixedThreadPool(GlobalPara.numOfClients);
	  PrintWriter out = res.getWriter();
	  
//	  int num=ran.nextInt(10)+1;
//		  
//	  int id=TPCW_dataservice.fina_createEmptyCart();
//	 // TPNode.LTM.checkpoint();
//	  int[] itemids=new int[num];
//	  int[] itemqtys=new int[num];
//	  for(int i=0;i<num;i++)
//	  	{
//		  int i_id=ran.nextInt(GlobalPara.sysConf.NUM_ITEMS)+1;
//		  itemids[i]=i_id;
//		  itemqtys[i]=ran.nextInt(5)+1;
//		  if(i_id<0)
//			  System.out.println("Item id <0");
//		  TPCW_dataservice.fina_addItem(id, i_id);
//	  	}
//
//	  TPCW_dataservice.fina_refreshCart(id, itemids,itemqtys );
//	  TPCW_dataservice.fina_resetCartTime(id);
//	  
//	  //TPNode.LTM.checkpoint();
//	  
//	  TPCW_dataservice.fina_getShortCart(id);
//	  
//	  Cart cart=new Cart(itemids, itemqtys);
//	  
//	  int c_id=ran.nextInt(TPCWDataModel.NUM_CUSTOMERS)+1;
//	  TPCW_dataservice.fina_purchaseTransaction(c_id, id, cart,22, 33, 44, "shipping", 0.8,
//					"cc_type",
//					   1000,
//					   "cc_name",
//					   "2008-10-10",
//					   1000);
//	 TPCW_dataservice.fina_getLastestOrderInfo(c_id);
//	 /* TPCW_dataservice.fina_getLastestOrderInfo(1001);
//	  TPCW_dataservice.fina_getLastestOrderInfo(1001);
//	  TPCW_dataservice.fina_getLastestOrderInfo(1001);*/
//	 //TPNode.LTM.checkpoint();
////	  if(true)
////		  return;
	 testFinaLoad.startTime=System.currentTimeMillis();
	  int count=0;
	  long startingInterval=warmupInterval*2/3;
	  long sleeptime;
	  if(GlobalPara.numOfClients>=10)
		  sleeptime=startingInterval/(GlobalPara.numOfClients/10);
	  else
		  sleeptime=1000;
	 // sleeptime=1000;
	  GlobalPara.logger.warning("Sleep "+sleeptime+" ms to slow down the warmup process");
		while(count<GlobalPara.numOfClients)
			{
				testFinaLoad a =new testFinaLoad();
				clientExecutor.submit(a);
				count++;
				if(count%10==0)
					{
						try {
							GlobalPara.logger.warning("Thread "+count+" submitted. Sleep "+sleeptime+" ms to slow down the warmup process");
							Thread.sleep(sleeptime);
						} catch (InterruptedException e) {
							e.printStackTrace();
						}
					}
			}
		clientExecutor.shutdown();
		try {
			clientExecutor.awaitTermination(GlobalPara.testDuration, TimeUnit.MILLISECONDS);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
//		MsgBroker.DoCheckPoint(2);
//		MsgBroker.DoCheckPoint(3);
	  out.write("Test Service Done");
	  out.close();
}
	
	public void doPost(HttpServletRequest req, HttpServletResponse res)
    throws IOException, ServletException {
		ServletInputStream in=req.getInputStream();
		byte[] buffer=new byte[100];
		int len=in.read(buffer);
		String result=new String(buffer);
		System.out.println(result);
		System.out.println(len);
	}
}
