package org.zhouw.stps;

import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.tp.GlobalTransManager;

public class TranBgExec implements Runnable  {

	//public static java.util.concurrent.locks.ReentrantLock lock=new ReentrantLock() ;
	public static int totalCount=0;
	private Transaction t;
	private int id;
	public TranBgExec(Transaction t, int id)
	{
		this.t=t;
		this.id=id;
	}
	public void run()  {
		if(this.id==1)
			{
			@SuppressWarnings("unused")
			int di=23;
			}
		TransactionResult result= TransExecutor.runTransaction(t);
		
		//lock.lock();
		try{
			if(result.state==TranState.ABORT)
				GlobalPara.logger.warning("Transaction "+id+"Aborted");
			else
				{
				//GlobalPara.logger.warning("Transaction Successfully Committed\nResult:"+t.printOutput());
				//TestMain.verify(t.output);
				verify(result.result);
				//GlobalPara.logger.warning("Transaction "+id+" Succeed"+printStrArray(result.result));
				}
		}
		finally{
				//lock.unlock();
			}
		return;
	}
	
	private String printStrArray(String[][] a)
	{
		if(a!=null)
		{
		String result="Returned value from transaction: \n";
		for(String[] s:a)
			result+=s[0] + ":"+s[1]+"\n";
		return result;
		}
		else
			return "Returned result is empty";
	}
	/**
	 * Acount:Money:24200
	 * Acount:Money:25800
	 * Acount:Money:4200
	 * @param input
	 * @return
	 */
	public static boolean verify(String[][] input)
	{
		if(input==null||input.length!=3)
			return true;
		Integer m1=Integer.valueOf(input[0][1]);
		Integer m2=Integer.valueOf(input[1][1]);
		Integer amount=Integer.valueOf(input[2][1]);
		if(m1+m2!=50000&&m1+amount!=50000&&m2+amount!=50000)
			{
			GlobalPara.logger.severe("++++++++++++++++++++Verify failed, inConsistent data: '"+m1+"' + '"+m2+"' = '"+amount+"'");
			return false;
			}
		else
			{
			GlobalPara.logger.severe("*************************Consistent data******************");
			//if(((m1-m2+10000)/2)!=(amount))
			//	GlobalPara.logger.severe("++++++++++++++++++++Verify failed, inConsistent data: '("+m1+"' - '"+m2+"+10000)/2' = '"+((m1-m2+10000)/2)+"' != "+ (amount));
			//else
//				{
//				GlobalPara.logger.severe("Verify successful: '"+m1+"' + '"+m2+"' = '"+(m1+m2)+"'\n"+"("+m1+" - "+m2+"+10000)/2' = '"+((m1-m2+10000)/2)+"' = "+ (amount));
//				}
			return true;
			}
	}
}
