package org.zhouw.stps.app.otpcw;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.TransactionResult;
import org.zhouw.stps.rotran.QueryPlan;
import org.zhouw.stps.rotran.ROTranResult;
import org.zhouw.stps.client.*;
import org.zhouw.stps.tp.*;
import org.zhouw.stps.app.common.*;
import org.zhouw.stps.app.otpcw.sql.TPCW_Database;

import java.util.Vector;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class TPCWWorkload {

//	public static int countOfCart=0;
//	public static int countOfAddress=GlobalPara.sysConf.NUM_ADDRESSES;
//	public static int countOfOrders=GlobalPara.sysConf.NUM_ORDERS;
	
	public static void evaluate()
	{
		//for(int i=0;i<GlobalPara.numOfClients;i++){
		
//		QueryPlan plan=TPCWQueries.getShortOrder(333);
//		ROTranResult result=TransExecutor.runROTran(plan, "getShortOrder");
//		
//		plan=TPCWQueries.getShortOrder(33333);
//		result=TransExecutor.runROTran(plan, "getShortOrder");
		
		ExecutorService executor=Executors.newCachedThreadPool(); 
		
		//long startingInterval=250000L;
		//long startingInterval=10000L;
		long startingInterval=100000L;
		long sleeptime;
		 if(GlobalPara.numOfClients>0)
			  sleeptime=startingInterval/(GlobalPara.numOfClients);
		  else
			  sleeptime=300;
		
		 //Vector<Future> tasks=new Vector<Future>(); 
		 long startTime=System.currentTimeMillis();
		 
		 if(GlobalPara.sysConf.isRelational)
				TPCW_Database.init();
		for(int i=0;i<GlobalPara.numOfClients;i++){
			
			if(!GlobalPara.sysConf.isRelational){
				EB eb=new EB(i,startTime);
				executor.submit(eb);
			} else {
				EBAccessRDBMS eb=new EBAccessRDBMS(i,startTime);
				executor.submit(eb);
			}
//			if(i%10==0&&i!=0){
				try {
					Thread.sleep(sleeptime);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
//			}
		}
		long duration=System.currentTimeMillis()-startTime;
		long waittime=GlobalPara.sysConf.testDuration-duration;
		executor.shutdown();
		
		try {
			Thread.sleep(waittime);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
	}
	
	public static ROTranResult test(){
//		QueryPlan plan=TPCWQueries.getItemAndAuthor(1);
//		ROTranResult result=TransExecutor.runROTran(plan, "getItem");
//		QueryPlan plan=TPCWQueries.getCustomer("");
//		ROTranResult result=TransExecutor.runROTran(plan, "getCustomer");
//		QueryPlan plan=TPCWQueries.getRelatedItem(1);
//		ROTranResult result=TransExecutor.runROTran(plan, "getRelatedItem");
//		QueryPlan plan=TPCWQueries.getOrder(10);
//		ROTranResult result=TransExecutor.runROTran(plan, "getOrder");
//		QueryPlan plan=TPCWQueries.getShopppingCart(10);
//		ROTranResult result=TransExecutor.runROTran(plan, "getShopppingCart");
//		QueryPlan plan=TPCWQueries.getShortOrder(333);
//		ROTranResult result=TransExecutor.runROTran(plan, "getShortOrder");
//		QueryPlan plan=TPCWQueries.getItemAndAuthorBySubject("MYSTERY");
//		ROTranResult result=TransExecutor.runROTran(plan, "getItemAndAuthorBySubject");
//		QueryPlan plan=TPCWQueries.getAllOrders("OG");
//		ROTranResult result=TransExecutor.runROTran(plan, "getAllOrders");
		Transaction tran;
		TransactionResult result;
		
//		tran=TPCWTransactions.getUpdateItem(1);
//		result=TransExecutor.runTransaction(tran);
		
		tran=TPCWTransactions.getUpdateRelatedItem(15);
		ThreadedTran tranTask=new ThreadedTran(tran);
		tranTask.start();
		
		QueryPlan plan=TPCWQueries.getShortOrder(333);
		ThreadedROTran rotranTask=new ThreadedROTran(plan, "getShortOrder");
		rotranTask.start();
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getNewShoppingCart(countOfCart);
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getRefreshCartLine(countOfCart, 0);
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getRefreshCartLine(countOfCart, 1);
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getDeleteCartLine(countOfCart, 0);
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getRefreshCartLine(countOfCart, 2);
//		result=TransExecutor.runTransaction(tran);
//		
//		tran=TPCWTransactions.getPurchase(countOfCart, countOfOrders);
//		result=TransExecutor.runTransaction(tran);
		
//		if(result!=null){
//			System.out.println(result.state);
//		}else{
//			System.out.println("Transaction return result null");
//		}
//		countOfCart++;
//		countOfOrders++;
		return null;
	}
}
