package org.zhouw.stps.app.tpcw;

public class CmdExecuterPool {
	public int NUMOFTHREADS=1000;  
	private  CmdExecuter[] executers=new CmdExecuter[NUMOFTHREADS];
	private  CmdExecuter[] estack=new CmdExecuter[NUMOFTHREADS];
	private  int pointer=0;
	
	public CmdExecuterPool()
	{
		for(int i=0;i<NUMOFTHREADS;i++)
			{
			executers[i]=new CmdExecuter("","");
			estack[i]=executers[i];
			}
	}
	public synchronized int getNumOfUsedExecuters()
	{
		return pointer;
	}
	
	public CmdExecuter getExecuter()
	{
		return pop();
	}
	
	public synchronized CmdExecuter pop()
	{
		
		if(pointer<NUMOFTHREADS)
			{
			return estack[pointer++];
			}
		else
			return null;
	}
	
	public void push(CmdExecuter ce)
	{
		if(pointer>0)
			{
			estack[pointer--]=ce;
			}
		else
			System.err.println("[Error!!] the executor thread pool stack overflows!!");
	}
}
