package org.zhouw.stps.app.tpcw;
import java.sql.Date;
import java.sql.ResultSet;


public class OrderShort {
			public int o_id;
    public Date o_date;
    public double o_subtotal;
    public double o_tax;
    public double o_total;
    public String o_ship_type;
    public Date o_ship_date;
    public String o_status;
    public String cx_type;
    	public int o_bill_addr_id;
    	public int o_ship_addr_id;
    
    public OrderShort()
    		{}
    
    public OrderShort(ResultSet rs) {
    		
    	try {
    	    o_id = rs.getInt("o_id");
    	    o_date = rs.getDate("o_date");
    	    o_subtotal = rs.getDouble("o_sub_total");
    	    o_tax = rs.getDouble("o_tax");
    	    o_total = rs.getDouble("o_total");
    	    o_ship_type = rs.getString("o_ship_type");
    	    o_ship_date = rs.getDate("o_ship_date");
    	    o_status = rs.getString("o_status");
    	    cx_type = rs.getString("cx_type");
    	    o_bill_addr_id=rs.getInt("o_bill_addr_id");
    	    o_ship_addr_id=rs.getInt("o_ship_addr_id");
    			} catch (java.lang.Exception ex) {
    	    ex.printStackTrace();
    				}
        }
    
   	public OrderShort(int o_id,
						    							Date o_date,
						    	         double o_subtotal,
						    	         double o_tax,
						    	         double o_total,
						    	         String o_ship_type,
						    	         Date o_ship_date,
						    	         String o_status,
						    	         String cx_type,
						    	        	 int o_bill_addr_id,
						    	        	 int o_ship_addr_id)
    		{
    					this.o_id=o_id;
    					this.o_date=o_date;
    					if(o_date==null)
    					this.o_date=Date.valueOf("2007-01-01");
    					this.o_subtotal=o_subtotal;
    					this.o_tax=o_tax;
    					this.o_total=o_total;
    					this.o_ship_type=o_ship_type;
    					this.o_ship_date=o_ship_date;
    					this.o_status=o_status;
    					this.cx_type=cx_type;
    					this.o_bill_addr_id=o_bill_addr_id;
    					this.o_ship_addr_id=o_ship_addr_id;
    		}
    	
   public String serialize()
	     {
	 	  		String d=TPCW_globleParam.delimiter;
	     	String s= String.format("%d%s%s%s%f%s%f%s%f%s%s%s%s%s%s%s%s%s%d%s%d",
	     			o_id,d,
	     			o_date.toString(),d,
	     			o_subtotal,d,
	     			o_tax,d,
	     			o_total,d,
	     			o_ship_type,d,
	     			o_ship_date.toString(),d,
	     			o_status,d,
	     			cx_type,d,
	     			o_bill_addr_id,d,
	     			o_ship_addr_id);
	     	return s;
	     }
	   
	   //return -1 when the input is not valid,0 means ok
	  public static OrderShort deSerialize(String order)
	 	  { 
		   	if(order==null) return null;
		   	OrderShort o=new OrderShort();
	 		  	String result[]=	order.split(TPCW_globleParam.delimiter);
	 		  	try{
        o.o_id=Integer.valueOf(result[0]);
					o.o_date=Date.valueOf(result[1]);
					o.o_subtotal=Double.valueOf(result[2]);
					o.o_tax=Double.valueOf(result[3]);
					o.o_total=Double.valueOf(result[4]);
					o.o_ship_type=result[5];
					o.o_ship_date=Date.valueOf(result[6]);
					o.o_status=result[7];
					o.cx_type=result[8];
					o.o_bill_addr_id=Integer.valueOf(result[9]);
					o.o_ship_addr_id=Integer.valueOf(result[10]);
	 		  	}
	 		 	catch (NumberFormatException e)
	 		  	{e.printStackTrace();}
	 		 	catch (NullPointerException e)
	 		  	{e.printStackTrace();}
    return o;
	 	  }
    
}
