package org.zhouw.stps.app.tpcw.transactions;

import java.util.Hashtable;

import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAResetCartTime extends SubTransaction {

	public FINAResetCartTime(String strRowKey, Hashtable<String,String> h) {
		super("FINAResetCartTime", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public FINAResetCartTime(String strRowKey) {
		super("FINAResetCartTime", TPCWDataModel.name,TPCWDataModel.SHOPPINGTABLENAME, 
				strRowKey, null, false,false, false);
	}
	
	public TranState run()
	{
		TranState result;
		try{
//		if(super.run()==TranState.ABORT)
//			return TranState.ABORT;// it is an insert operation, it should be null
		super.run();
		this.DataToPut=new String[1][2];
		this.DataToPut[0][0]=TPCWDataModel.CSC_TIME;
		this.DataToPut[0][1]=String .valueOf(System.currentTimeMillis());
		this.DataToDelete=null;
		this.DataToReturn=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
