package org.zhouw.stps.components;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionResultSetMsg;
import org.zhouw.stps.rotran.ROTranMsg.ROTranResultMsg;
import org.zhouw.stps.tp.TPNode;

public class ClientComponent extends Component {

	public ClientComponent() {
		super("Client");
		
	}

	@Override
	public void handler(CompMessage msg) {
		switch(msg.type){
		case CompMessage.CLIENT_GET_RORESULT:
			ToClient_ResultMsg romsg=(ToClient_ResultMsg)msg;
			TransExecutor.returnROTranResult(romsg.romsg);
			break;
		case CompMessage.CLIENT_GET_RWRESULT:
			ToClient_ResultMsg rwmsg=(ToClient_ResultMsg)msg;
			TransExecutor.returnRWTranResult(rwmsg.rwmsg);
			break;
		}
	}

	public void submitRWTranResult(TransactionResultSetMsg rwmsg){
		ToClient_ResultMsg msg=new ToClient_ResultMsg(rwmsg);
		this.sendMsg(msg);
	}
	
	public void submitROTranResult(ROTranResultMsg romsg){
		ToClient_ResultMsg msg=new ToClient_ResultMsg(romsg);
		this.sendMsg(msg);
	}
}
