package org.zhouw.stps.components;

import java.util.Vector;
import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.CountDownLatch;

import org.zhouw.stps.tp.UpdatesOfST;

public class LTMtoLTM_BackupCommitData extends CompMessage {

	public static final int UPDATE=130;
	public static final int REMOVE=131;
	
	public Vector<UpdatesOfST> data;
	public ArrayBlockingQueue<Integer> queue;

	public LTMtoLTM_BackupCommitData(int typeid, UpdatesOfST data) {
		super(0, typeid);
		this.data=new Vector<UpdatesOfST>();
		this.data.add(data);
		this.queue=null;
	}
	
	public LTMtoLTM_BackupCommitData(Vector<UpdatesOfST> data, ArrayBlockingQueue<Integer> queue) {
		super(0, UPDATE);
		this.data=data;
		this.queue=queue;
	}
}
