package org.zhouw.stps.components;

import java.util.Vector;

import org.zhouw.stps.tp.RingMembership;

public class MemberTo_StartRecoverMsg extends CompMessage {

	
	public static final int BEGIN_RECOVERY=51;
	public static final int BEGIN_ACCEPT_TRANS=52;
	public static final int BEGIN_COMMIT=53;
	
	public static final int LOCAL_WORKINGDATA_COMPLETE=54;
	public static final int LOCAL_BACKUPDATA_COMPLETE=55;
	
	
	public Vector<Integer> failedNodes;
	public RingMembership newMembership;
	
	public MemberTo_StartRecoverMsg(int type) {
		super(0, type);
	}

	public MemberTo_StartRecoverMsg(int type, RingMembership newMembership, Vector<Integer> failedNodes) {
		super(0, type);
		this.newMembership=newMembership;
		this.failedNodes=failedNodes;
	}
	
}
