package org.zhouw.stps.components;

import org.zhouw.stps.app.DataTable;
import org.zhouw.stps.tp.DataRowContainer;
import org.zhouw.stps.tp.DataRowEntry;

public class ToAdapter_ReadARowForWhenRecovery extends CompMessage {

	DataRowContainer backupRow;
	DataRowEntry row;
	
	DataTable table;
	String rowKey;
	
	public static final int READ_PRIMARY_RECOVERY=310;
	public static final int READ_BACKUP_RECOVERY=311;
	
	public ToAdapter_ReadARowForWhenRecovery(DataRowEntry row) {
		super(0, READ_PRIMARY_RECOVERY);
		this.table=row.dataTable.tableSchema;
		this.rowKey=row.rowKey;
		this.row=row;
	}
	
	public ToAdapter_ReadARowForWhenRecovery(DataTable table,
	String rowKey,DataRowContainer row) {
		super(0, READ_BACKUP_RECOVERY);
		this.table=table;
		this.rowKey=rowKey;
		this.backupRow=row;
	}

}
