package org.zhouw.stps.membership;

import org.zhouw.stps.*;

public class StartInvitationTask implements Runnable {
	int failureTimes;
	boolean isStartNow;
	
	public void run() {
		long sleeptime=0;
		if(!isStartNow){
			sleeptime=MembershipManager.getRetryInterval();
			try {
				Thread.sleep(sleeptime); //to avoid conflicts because of concurrency control 
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
		do{
			if(MembershipManager.failureTimes!=failureTimes)
				break;
			GlobalPara.memberComp.startInvitation(failureTimes);
			sleeptime=MembershipManager.getRetryInterval();
			if(sleeptime>0){
				try {
					Thread.sleep(sleeptime); //to avoid conflicts because of concurrency control 
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}while(true);
		
		
	}
	
	
	public StartInvitationTask(int failureTimes, boolean isStartNow) {
		super();
		this.failureTimes=failureTimes;
		this.isStartNow=isStartNow;
	}

}
