package org.zhouw.stps.monitor;

public class IDServiceLogItem extends LogItem {

	public long latency;
	public long timestamp;

	public IDServiceLogItem(long latency, long timestamp) {
		super();
		this.latency = latency;
		this.timestamp = timestamp;
	}
	
	public IDServiceLogItem()
	{}
	
	@Override
	public void fillFied(String[] paras)
	{
		if(paras.length<2)
			return;
		 if(paras[0].compareTo("latency")==0)
			this.latency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("timestamp")==0)
			this.timestamp=Long.valueOf(paras[1]);
	}

	@Override
	public String writeToString() {
		String result="{\n";
		result+="latency="+ this.latency+"\n";
		result+="timestamp="+ this.timestamp+"\n";
		result+="}";
		return result;
	}



}
