package org.zhouw.stps.monitor;

import java.util.LinkedList;
import java.util.List;

public class ServerTransactionLogItem extends LogItem {
	
	 public long totalLatency;
//	 public long submitLatency;
//	 public long waitLatency;
//	 public long abortLatency;
//	 public long doCommitLatency;
	 
	 public String name;
	 //public int restartTimes;
	 //public int[] STGDestTPNodeID;
	 public boolean isReadOnly;
	 public boolean isCommitted;
	 
	 public List<String> accessedRecords;
	 
	 public long timestamp;
	
	 public ServerTransactionLogItem()
	 {
		 accessedRecords=new LinkedList<String>();
	 }
	 
	 /**
	  * NumOfDestIDs must appear before the rest TPNodeID
	  */
		public void fillFied(String[] paras)
		{
			if(paras.length<2)
				return;
			if(paras[0].compareTo("totalLatency")==0)
				this.totalLatency=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("timestamp")==0)
				this.timestamp=Long.valueOf(paras[1]);
			else if(paras[0].compareTo("name")==0)
				this.name=paras[1];
			else if(paras[0].compareTo("isReadOnly")==0)
				this.isReadOnly=Boolean.valueOf(paras[1]);
			else if(paras[0].compareTo("isCommitted")==0)
				this.isCommitted=Boolean.valueOf(paras[1]);
			else if(paras[0].compareTo("record")==0)
				accessedRecords.add(paras[0]);
		}

	@Override
	public String writeToString() {
		String result="{\n";
		result+="totalLatency=" + this.totalLatency+ "\n";
		result+="name=" + this.name+ "\n";
		result+="isReadOnly=" + this.isReadOnly+ "\n";
		result+="isCommitted=" + this.isCommitted+ "\n";
		result+="timestamp=" + this.timestamp+ "\n";
		for(String record:accessedRecords){
			result+="record="+record+"\n";
		}
		result+="}";
		return result;
	}
}
