package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.msg.MsgUtil;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ResultSetMsg;
import org.zhouw.stps.tp.TPNode;

public class DoCommitTask implements Callable<Integer> {

	public int destID;
	public long timestamp;
	public String key;
	public DoCommitTask(int destID, long timestamp, String key)
	{
		this.destID=destID;
		this.timestamp=timestamp;
		this.key=key;
	}
	public Integer call() {
		int result=0;
		if(destID==GlobalPara.sysConf.getLocalNodeID()){
			GlobalPara.ltmComp.doCommitSTG(key);
		} else {
			String parameters="?timestamp="+timestamp+"&key="+key;
			MsgBroker.GetMessage(destID, parameters, "DoCommitService");
		}
		//GlobalPara.logger.info("Succesfully deliver DOCommit messages for TC" + timestamp);
		return result;
	}

}
