package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;

public class DoDataPopulateTask implements Callable<String> {

	private int destID;
	public DoDataPopulateTask(int destID)
	{
		this.destID=destID;
	}

	public String call() throws Exception {
		String result="F";
		String ip=GlobalPara.sysConf.getIP(destID);
		String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/DoDataPopulateService";
		url+="?destID=" +destID;
		InputStream in= MsgBroker.doHttpGet(url);
		if(in!=null)
		{
			try {
				while(in.read()!=-1)
					{;}
				in.close();
				result="S";
			} catch (IOException e) {
				//e.printStackTrace();
			}
		}
		else
			result=null;
		return result;
	}

}
