package org.zhouw.stps.tools;

import java.util.concurrent.Callable;
import org.zhouw.stps.*;
import org.zhouw.stps.tp.*;

public class StartNPToOneLTMTask implements Callable<Integer> {

	private int destID;
	private int numOfPart;
	
	public Integer call() throws Exception {
		
		String ip=GlobalPara.sysConf.getIP(destID);
		String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/SimulateNetworkPartitionService?num="+numOfPart;
		MsgBroker.doHttpGet(url);
		
		return null;
	}

	public StartNPToOneLTMTask(int destID, int numOfPart) {
		super();
		this.destID = destID;
		this.numOfPart = numOfPart;
	}

}
