package org.zhouw.stps.monitor;

public class ClientTransactionLogItem extends LogItem {

	public String name;
	public long latency;
	public boolean isCommitted;
	public long timestamp;
	public int numAccessedItems;
	public boolean isReadonly;
	
	public ClientTransactionLogItem()
	{}
	
	@Override
	public void fillFied(String[] paras)
	{
		if(paras.length<2)
			return;
		if(paras[0].compareTo("name")==0)
			this.name=paras[1];
		else if(paras[0].compareTo("latency")==0)
			this.latency=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("isCommitted")==0)
			this.isCommitted=Boolean.valueOf(paras[1]);
		else if(paras[0].compareTo("timestamp")==0)
			this.timestamp=Long.valueOf(paras[1]);
		else if(paras[0].compareTo("numAccessedItems")==0)
			this.numAccessedItems=Integer.valueOf(paras[1]);
		else if(paras[0].compareTo("isReadonly")==0)
			this.isReadonly=Boolean.valueOf(paras[1]);
	}
	
	public ClientTransactionLogItem(String name, long latency, boolean isCommitted, long timestamp, int numAccessedItems, boolean isReadonly)
	{
		this.name=name;
		this.latency=latency;
		this.isCommitted=isCommitted;
		this.timestamp=timestamp;
		this.numAccessedItems=numAccessedItems;
		this.isReadonly=isReadonly;
	}
	public String writeToString()
	{
		String result="{\n";
		result+="name="+this.name+"\n";
		result+="latency="+this.latency+"\n";
		result+="isCommitted="+this.isCommitted+"\n";
		result+="timestamp="+this.timestamp+"\n";
		result+="numAccessedItems="+this.numAccessedItems+"\n";
		result+="isReadonly="+this.isReadonly+"\n";
		result+="}";
		return result;
	}
	
	public void readFrom()
	{}
}
