package org.zhouw.stps.monitor;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

import java.util.TreeMap;
import java.util.Set;
import java.util.Map.Entry;
import java.util.*;

public class bufferSizeAnalyzer {

	public static void main(String[] args) {
		if(args.length<2)
			return;

		String outfileName=args[0];
		String[] inputFile=new String[20];
		int count=1;
		String inPath=args[1];
		
		for(int i=1;i<21;i++)
			inputFile[i-1]=inPath+i+".hitmiss";
		
		if(outfileName==null)
			return;
		
		TreeMap<Integer, Integer> bufferSize=new TreeMap<Integer, Integer>();
		
		try {
				BufferedWriter writerOverview=new BufferedWriter(new FileWriter(outfileName,false));
				for(int i=0;i<inputFile.length;i++)
				{
					FileInputStream fstream = new FileInputStream(inputFile[i]);
					BufferedReader in = new BufferedReader(new InputStreamReader(fstream));
					String line=in.readLine();
					int time=0;
					while(line!=null)
					{
						if(line.startsWith("#"))
							{
							line=in.readLine();
							continue;
							}
						
						//int len=line.length();
						String tmp=line;
						do
						{
							tmp=line;
							line=line.replaceAll("  ", " ");
						}
						while(tmp.compareTo(line)!=0);
						String[] paras=line.split(" ");
						
//						System.out.println(line);
//						System.out.println(paras[0]+ " dd "+ paras[1]);
						
//						Integer time=Integer.valueOf(paras[1]);
//						if(time%5!=0)
//							time--;
						int offset=0;
						if(paras[0].compareTo("")==0)
							offset=1;
						Integer size=Integer.valueOf(paras[7+offset]);
						Integer t=bufferSize.get(time);
						if(t==null)
							bufferSize.put(time, size);
						else
							bufferSize.put(time, size+t);
						time+=5;
						line=in.readLine();
					}
					fstream.close();
				}
						
				Set<Entry<Integer, Integer>> sets=bufferSize.entrySet();
				Iterator<Entry<Integer, Integer>> entires= sets.iterator();
				int sum=0;
				int num=0;
				while(entires.hasNext())
				{
					Entry<Integer, Integer> e=entires.next();
					Integer key=e.getKey();
					Integer value=e.getValue();
					if(key>300&&key<900)
						{
						sum+=value;
						num++;
						}
					writerOverview.write(key + " "+value);
					writerOverview.newLine();
				}
				sum/=num;
				writerOverview.write("Average: "+ sum + " Each with "+ sum/20);
				writerOverview.flush();
				writerOverview.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
}
