import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.UpdateOnDataRowMsg;
import org.zhouw.stps.tp.*;

public class DoBackUpCommitService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("DoBackUpCommitService receive empty input, abort execution");
				return;
				}
			UpdateOnDataRowMsg msg=UpdateOnDataRowMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct UpdateOnDataRowMsg object failed with input content, abort execution");
				return;
				}
			UpdatesOfST data=new UpdatesOfST(msg);
			MsgBroker.cleanupInputStream(in);
			GlobalPara.ltmComp.doBackupCommittedDataUpdates(data);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
