import java.util.Vector;
import java.util.concurrent.LinkedBlockingDeque;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.components.CompMessage;
import org.zhouw.stps.components.LTMComponent;
import org.zhouw.stps.components.MembershipComponent;
import org.zhouw.stps.components.ROGTMComponent;
import org.zhouw.stps.components.RWGTMComponent;

public class DoDebugService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		
		GlobalPara.logger.warning("[DEBUG]Receive Start debug message, Send debug requests");
		CompMessage msg=new CompMessage(0, CompMessage.START_DEBUG);
		GlobalPara.debugQueue=new LinkedBlockingDeque<String>();
		
		//print debug messages into tomcat log
		GlobalPara.roComp.sendMsg(msg);
		GlobalPara.rwComp.sendMsg(msg);
		GlobalPara.ltmComp.sendMsg(msg);
		GlobalPara.memberComp.sendMsg(msg);
		
		Vector<String> results=new Vector<String>(); 
		do{
			try {
				String out=GlobalPara.debugQueue.take();
				results.add(out);
				GlobalPara.logger.warning("[DEBUG]"+out+"finish debug");
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}while(results.size()!=4);
	}

}
