import java.io.IOException;
import java.io.InputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.components.RWGTMtoRWGTM_UpdateTCMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.BackupTransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.ReportCommitMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransCoodinatorMsg;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.MsgBroker;


public class DoUpdateBackupTCService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		long id=-1;
		InputStream in;
		try {
			in = req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("DoUpdateBackupTCService receive empty input, abort execution");
				return;
				}
			BackupTransactionMsg msg=BackupTransactionMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct ReportCommitMsg object failed with input content, abort execution");
				return;
				}
			GlobalPara.rwComp.requestUpdateBackupTC(msg);
			MsgBroker.cleanupInputStream(in);
		} catch (IOException e) {
			e.printStackTrace();
			//failure during update, the original TC is failed. Waiting for master to synchronize
		}

	}

}
