import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.membership.msg.MembershipMsg.LastestMembershipMsg;
import org.zhouw.stps.GlobalPara;


public class GetLatestMembershipService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		
		GlobalPara.logger.warning("Client request new timestamp");
		LastestMembershipMsg msg=MembershipManager.getLatestMembership();
		GlobalPara.logger.warning("Client obtained new timestamp "+ msg.getVersion());
		
		OutputStream output;
		try {
			output=res.getOutputStream();
			msg.writeTo(output);
			output.flush();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		GlobalPara.logger.warning("New timestamp "+ msg.getVersion() + " returned to client");
	}

}
