import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.master.*;

public class InformToMasterRecoveryProcessService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		String type=req.getParameter("type");
		String strTPID=req.getParameter("NodeID");
		if(type==null||strTPID==null)
			return;
		int tpid=Integer.valueOf(strTPID);
		int result=1;
		if(type.compareTo("tran")==0)
			result=MasterServer.recovery.reportTranRecoveryComplete(tpid);
		else if(type.compareTo("total")==0)
			result=MasterServer.recovery.reportTotalRecoveryComplete(tpid);
		
		PrintWriter out;
		try {
			out = res.getWriter();
			out.println(result);
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
