import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.zhouw.stps.tp.*;
import org.zhouw.stps.*;


public class NotifyNodeFailures extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {

		String strCount = req.getParameter("count");
		if(strCount==null)
			return;
		int count=Integer.valueOf(strCount);
		int[] nodes=new int[count];
		for(int i=0;i<count;i++)
			{
			String strNodeID=req.getParameter("node"+i);
			if(strNodeID!=null)
				{
				nodes[i]=Integer.valueOf(strNodeID);
				}
			else
				{
				nodes[i]=-1;
				GlobalPara.logger.warning("The number of failed nodes and the actual node id do not match");
				}
			}
		//TPNode.reportFailedNodes(nodes);
	}

}
