import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.membership.MembershipManager;
import org.zhouw.stps.membership.msg.MembershipMsg.SendPartitionMembershipCommitMsg;

public class ReceivePartitionMembershipCommitService extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		
		InputStream in;
		OutputStream output;
		try {
			in=req.getInputStream();
			if(in!=null) {
				SendPartitionMembershipCommitMsg msg=SendPartitionMembershipCommitMsg.parseFrom(in);
				
				int srcID=msg.getSrcID();
				boolean isKeepLock=msg.getIsKeepLock();
				
				Vector<Integer> curPartition=new Vector<Integer>();
				curPartition.addAll(msg.getCurPartitionList());
				GlobalPara.memberComp.reportReceivePartitionCommit(srcID, curPartition, isKeepLock);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
