import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.TimeUnit;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.TranState;
import org.zhouw.stps.TransCoodinator;
import org.zhouw.stps.Transaction;
import org.zhouw.stps.client.TransExecutor;
import org.zhouw.stps.msg.SubTransactionGroupProtos.Parameter;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionMsg;
import org.zhouw.stps.msg.SubTransactionGroupProtos.TransactionResultSetMsg;
import org.zhouw.stps.tp.GlobalTransManager;
import org.zhouw.stps.MsgBroker;


public class ReturnGlobalTransactionResult extends ManagedHttpServlet {

	@Override
	public void process(HttpServletRequest req, HttpServletResponse res) {
		try {
			InputStream in=req.getInputStream();
			if(in==null)
				{
				GlobalPara.logger.warning("Receive empty input, stop execution");
				return;
				}
			TransactionResultSetMsg msg=TransactionResultSetMsg.parseFrom(in);
			if(msg==null)
				{
				GlobalPara.logger.warning("Consturct TransactionMsg object failed with input content, abort execution");
				return;
				}
			//MsgBroker.cleanupInputStream(in);
			if(GlobalPara.clientComp!=null)
				GlobalPara.clientComp.submitRWTranResult(msg);
			else
				GlobalPara.logger.warning("[Error]On clinet " + GlobalPara.sysConf.localNodeID+", its clientComp is null");
			//TransExecutor.returnRWTranResult(msg);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (Exception e){
			e.printStackTrace();
		}
	}

}


