
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.id.*;

public class TimestampService extends ManagedHttpServlet {
	
	public void process(HttpServletRequest req, HttpServletResponse res)
	{
		 long id=1;
		  PrintWriter out;
		try {
			if(GlobalPara.sysConf.doIdServiceServerSideMonitor){
				String strIsRestart=req.getParameter("isRestart");
				boolean isRestart=Boolean.getBoolean(strIsRestart);
				id=TimestampManager.getNewTimestamp(isRestart);
			} else {
				id=TimestampManager.getNewTimestamp();
			}
			
			out = res.getWriter();
			out.print(id);
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
