package org.zhouw.stps;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.membership.MembershipManager;

public class PostMessageTask implements Callable<Integer> {

	int destID;
	byte[] input;
	String servletName;
	
	 /*
	  * @return 0 if success, -1: failure
	  */
	public Integer call() throws Exception {
		
		int result= MsgBroker.PostMessage(destID, input, servletName);
		return result;
	}

	public PostMessageTask(int destID, byte[] input, String servletName) {
		super();
		this.destID = destID;
		this.input = input;
		this.servletName = servletName;
	}
}
