package org.zhouw.stps.app.common;

import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;

import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;

public class DeleteAllSubTransaction extends SubTransaction {

	public DeleteAllSubTransaction(String dbName,
			String strTblName, String strRowKey) {
		super("DeleteAllSubTransaction", dbName, strTblName, strRowKey, null,
				true, false, false);
	}
	
	public TranState run()
	{
		TranState result;
		try{
			if(super.run()==TranState.ABORT)
				return TranState.COMMIT; //Commit even row not existed
			HashMap<String, String> data= this.rootEntry.getCommittedData();
			this.DataToDelete=data.keySet().toArray(new String[data.keySet().size()]);
			this.DataToPut=null;
			this.DataToReturn=null;
			result=TranState.COMMIT;			
		}catch(java.lang.Exception e) {
			e.printStackTrace();
			result=TranState.ABORT;
		}
		return result;
	}
}
