package org.zhouw.stps.app.tpcw;

import java.io.IOException;

import java.util.concurrent.locks.ReentrantLock;
import org.apache.hadoop.hbase.HBaseConfiguration;
import org.apache.hadoop.hbase.client.HTable;
import org.apache.hadoop.hbase.client.Scanner;

import org.apache.hadoop.hbase.io.RowResult;
import org.zhouw.stps.*;
import org.zhouw.stps.monitor.IDServiceLogItem;

public class IDService {

	private static ReentrantLock lock=new ReentrantLock();
	private static int nextShoppingID=initID(); //rowkey of current latest row of shopping table
	
	
	private static int initID()
	{
//		HBaseConfiguration conf=TPCWDataModel.conf;
//		int result=0;
//		lock.lock();
//		try {
//			HTable table=new HTable(conf,TPCWDataModel.SHOPPINGTABLENAME);
//			//System.out.println(TPCWDataModel.rowCount[1]);//25641 //25920
//			Scanner scanner = table.getScanner(new String[]{TPCWDataModel.CSC_NUM_LINES}, TPCWDataModel.getStrIDFromInt(TPCWDataModel.rowCount[1]));
//			 RowResult rowResult = scanner.next();
//			 RowResult r=rowResult;
//			while(rowResult!=null)
//			{
//				r=rowResult;
//				rowResult= scanner.next();
//			}
//			String rowkey=new String(r.getRow());
//			result=Integer.valueOf(rowkey);
//			//System.out.println(rowkey);
//		} catch (IOException e) {
//			e.printStackTrace();
//		}
//		finally{
//			lock.unlock();
//		}
		return GlobalPara.sysConf.NUM_ORDERS;
		//return 15000;
	}
	
	public static int getShoppingID(boolean isNext) //if isNext then increase the ID
	{
		int result=0;
		lock.lock();
		try{
			if(isNext)
				nextShoppingID++;
			result=nextShoppingID;
		}
		finally{
			lock.unlock();
		}
		
		return result;
	}
}
