package org.zhouw.stps.app.tpcw;
import java.sql.*;

public class OrderLineShort {

	public OrderLineShort()
	{}
	
	public OrderLineShort(ResultSet rs) {
			try {
			    ol_i_id = rs.getInt("ol_i_id");
			    ol_qty = rs.getInt("ol_qty");
			    ol_discount = rs.getDouble("ol_discount");
			    ol_comments = rs.getString("ol_comments");
			} catch (java.lang.Exception ex) {
			    ex.printStackTrace();
			}
	    }

		public int ol_i_id;
		public int ol_qty;
		public double ol_discount;
		public String ol_comments;
		
		  public String serialize()
		    {
			  	String d=TPCW_globleParam.delimiter;
		    	String s= String.format("%d%s%d%s%f%s%s",
		    			ol_i_id,d,
							ol_qty,d,
							ol_discount,d,
							ol_comments);
		    	return s;
		    }
		  
		  //return -1 when the input is not valid,0 means ok
		  public static OrderLineShort deSerialize(String book)
			  {
			  		if(book==null) return null;
			  		OrderLineShort b=new OrderLineShort();
				  	String result[]=	book.split(TPCW_globleParam.delimiter);
				  	//if(result.length<5)
				  	//		return -1;
				  	try{
				  	b.ol_i_id = Integer.valueOf(result[0]);
				  	b.ol_qty = Integer.valueOf(result[1]);
				  	b.ol_discount = Double.valueOf(result[2]);
				  	b.ol_comments = result[3];
				  	}
				 	catch (NumberFormatException e)
				  	{}
				 	catch (NullPointerException e)
				  	{}
				   return b;
			  }
}

