package org.zhouw.stps.app.tpcw.transactions;


import java.util.Hashtable;

import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINACreateEmptyCart extends SubTransaction {

	public FINACreateEmptyCart(String strRowKey, Hashtable<String,String> h) {
		super("FINACreateEmptyCart", TPCWDataModel.name, TPCWDataModel.SHOPPINGTABLENAME, strRowKey, h, false,
				true, false);
	}
	
	public FINACreateEmptyCart(String strRowKey) {
		super("FINACreateEmptyCart", TPCWDataModel.name, TPCWDataModel.SHOPPINGTABLENAME, strRowKey, null, false,
				true, false);
	}

	public TranState run() {
		TranState result;
		try{
//		if(super.run()==TranState.COMMIT)
//			return TranState.ABORT;// it is an insert row operation, it should be null
			
		//super.run();	
		this.rootEntry.isDataLoaded=1;//compromise to save money when using SimpleDB
		
		this.DataToDelete=null;
		this.DataToPut=new String[2][2];
		this.DataToPut[0][0]=TPCWDataModel.CSC_TIME;
		this.DataToPut[0][1]=String.valueOf(System.currentTimeMillis());
		this.DataToPut[1][0]=TPCWDataModel.CSC_NUM_LINES;
		this.DataToPut[1][1]=String.valueOf(0);
		this.DataToReturn=new String[1][2];
		this.DataToReturn[0][0]="ShoppingID";
		this.DataToReturn[0][1]=this.strRowKey;
		
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
