package org.zhouw.stps.app.tpcw.transactions;

import java.util.Hashtable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class FINAUpdateLastestOrder extends SubTransaction {

	public FINAUpdateLastestOrder(String strRowKey, Hashtable<String,String> h) {
		super("FINAUpdateLastestOrder", TPCWDataModel.name,TPCWDataModel.LATESTORDERTABLENAME, strRowKey, h, false,
				false, false);
	}
	public FINAUpdateLastestOrder(String C_ID, String O_ID) {
		super("FINAUpdateLastestOrder", TPCWDataModel.name,TPCWDataModel.LATESTORDERTABLENAME, C_ID, null, false,
				false, false);
		this.parameters=new Hashtable<String,String>(2); 
		this.parameters.put("O_ID",O_ID);
	}

	public TranState run()
	{
		TranState result;
		try{
		super.run();//if the row exist or not would not affect the commit of the transaction
		String O_ID=this.parameters.get("O_ID");
		if(O_ID==null)
		{
			GlobalPara.logger.warning("FINAUpdateLastestOrder abort because O_ID is null");
			return TranState.ABORT;
		}
		this.DataToPut=new String[1][2];
		this.DataToPut[0][0]=TPCWDataModel.CLATEST_ORDER;
		this.DataToPut[0][1]=O_ID;
		this.DataToDelete=null;
		this.DataToReturn=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
