package org.zhouw.stps.app.tpcw.transactions;

import java.util.HashMap;
import java.util.Hashtable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.SubTransaction;
import org.zhouw.stps.SubTransactionGroup;
import org.zhouw.stps.TranState;
import org.zhouw.stps.app.tpcw.TPCWDataModel;

public class GetLatestOrderID extends SubTransaction {

	public GetLatestOrderID(String strRowKey, Hashtable<String,String> h) {
		super("GetLatestOrderID", TPCWDataModel.name,TPCWDataModel.LATESTORDERTABLENAME, strRowKey, h, false,
				false, false);
	}
	
	public GetLatestOrderID(String C_ID) {
		super("GetLatestOrderID", TPCWDataModel.name,TPCWDataModel.LATESTORDERTABLENAME, 
				C_ID, null, false,false, false);
	}
	public TranState run()
	{
		TranState result;
		try{
		if(super.run()==TranState.ABORT)
			{
			this.DataToReturn=new String[1][2];
			this.DataToReturn[0][0]="C_ID";
			this.DataToReturn[0][1]="-1";
			}
		else
			{
			HashMap<String, String> latestOrder= this.rootEntry.getCommittedData();
			String data=latestOrder.get(TPCWDataModel.CLATEST_ORDER);
			this.DataToReturn=new String[1][2];
			if(data==null)
				{
				GlobalPara.outputLog.warning("None of the order has been obtained!");
				this.DataToReturn[0][0]="C_ID";
				this.DataToReturn[0][1]="-1";
				}
			else
				{
				this.DataToReturn[0][0]="C_ID";
				this.DataToReturn[0][1]="-1";
				}
			}
		this.DataToDelete=null;
		this.DataToPut=null;
		result=TranState.COMMIT;
		}catch(java.lang.Exception e)
			{
				e.printStackTrace();
				result=TranState.ABORT;
			}
		return result;
	}
}
