package org.zhouw.stps.components;

public class ToRWGTM_GeneralInfo extends CompMessage {
	
	public static final int RETURN_RESULT_TO_CLIENT_SUCCESS=8;
	public static final int REPORT_UPDATE_TC_SUCCESS=11;
	public static final int REPORT_ABORT_DONE=9;
	public static final int REPORT_COMMIT_DONE=10;
	public static final int REMOVE_BACKUP_TC=12;
	
	
	public int stgIndex;
	public long timestamp;
	
	//RETURN_RESULT_TO_CLIENT_SUCCESS
	//REPORT_UPDATE_TC_SUCCESS
	public ToRWGTM_GeneralInfo(long GID, int typeid) {
		super(GID, typeid);
	}
	
	//REPORT_COMMIT_DONE
	public ToRWGTM_GeneralInfo(long GID, int typeid, int stgIndex) {
		super(GID, typeid);
		this.stgIndex=stgIndex;
	}

	//REPORT_ABORT_DONE, the abort of restarted derived transaction can be delayed
	public ToRWGTM_GeneralInfo(long GID, int typeid, int stgIndex, long timestamp) {
		super(GID, typeid);
		this.stgIndex=stgIndex;
		this.timestamp=timestamp;
	}
}
