package org.zhouw.stps.master;

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class ReportBackToNormalTask implements Callable {
	int destID;
	public Object call() throws Exception {
		int result=0;
		Hashtable<Integer, Long> achievedSnapshots=new Hashtable<Integer, Long>();
		
		if(destID==GlobalPara.sysConf.getLocalNodeID())
			{
				//TPNode.LTM.getRecoverTranCompleteMsg(achievedSnapshots);
			}
		else
			{
			String ip=GlobalPara.sysConf.getIP(destID);
			String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/NotifyFromMasterBackToNormalService";
			
			InputStream in= MsgBroker.doHttpGet(url);
			if(in!=null)
				{
					try{
						in.close();
					} catch (IOException e) {
						e.printStackTrace();
					}
				}
			}
		return result;
	}
	
	public ReportBackToNormalTask(int destID) {
		super();
		this.destID = destID;
	}

}
