package org.zhouw.stps.monitor;

import java.io.BufferedReader;
import java.io.IOException;

public abstract class LogItem {
	public LogItem()
	{}
	
	public abstract String writeToString();
	public abstract void fillFied(String[] paras);
	public int readFrom(BufferedReader in) throws IOException {
		int result=-1;
		String line;
		boolean startRead=false;
		do{
			line=in.readLine();
			if(line==null)
				{
				break;
				}
			if(startRead)
				{
					if(line.compareTo("}")==0)
					{
						result=0;
						break;
					}
					String[] paras=line.split("=");
					if(paras.length>=2)
						{
						fillFied(paras);
						}
				}
			else
				{
					if(line.compareTo("{")==0)
						startRead=true;
				}
		}
		while(line!=null);

		return result;
	}
}
