package org.zhouw.stps.net;

import java.io.IOException;
import java.io.InputStream;
import java.util.concurrent.Callable;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;
import org.zhouw.stps.tp.TPNode;

public class DoAbortTask implements Callable<Integer> {

	public int destID;
	public long timestamp;
	public String key;
	
	public DoAbortTask(int destID, long timestamp, String key)
	{
		this.destID=destID;
		this.timestamp=timestamp;
		this.key=key;
	}
	public Integer call() throws Exception {
		int result=0;
		if(destID==GlobalPara.sysConf.getLocalNodeID()){
			GlobalPara.ltmComp.doAbortSTG(key,timestamp);
		} else {
			String parameters="?timestamp="+timestamp+"&key="+key;
			MsgBroker.GetMessage(destID, parameters, "DoAbortService");
		}
		return result;
	}

}
