package org.zhouw.stps.tools;

import java.io.IOException;
import java.io.InputStream;

import org.zhouw.stps.GlobalPara;
import org.zhouw.stps.MsgBroker;

public class FailureDetector {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int[] failedNodes=new int[args.length];
		for(int i=0;i<failedNodes.length;i++)
			failedNodes[i]=Integer.parseInt(args[i]);
		int destID=GlobalPara.sysConf.getMasterID();
		String ip=GlobalPara.sysConf.getIP(destID);
		String url="http://"+ip + ":"+GlobalPara.sysConf.getPort(destID)+"/"+GlobalPara.sysConf.projectName+"/servlet/NofityMasterNodeFailureService";
		url+="?count="+failedNodes.length;
		for(int i=0;i<failedNodes.length;i++)
			{
				url+="&node"+i+"="+failedNodes[i];
			}
		InputStream in= MsgBroker.doHttpGet(url);
		if(in!=null)
			{
				try{
					in.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		System.out.println("FailedNodes successfully reported to master");
	}

}
