package org.zhouw.stps.tp;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.HashSet;

public class UpdatedDataRow {

	public String rowKey;
	
	public UpdatedDataRow(String rowKey, String[][] dataToPut, String[] dataTodelete)
	{
		updatedColumns=new Hashtable<String, String>();
		deletedColumns=new HashSet<String>();
		this.rowKey=rowKey;
		
		if(dataToPut!=null)
			for(String[] s: dataToPut)
				updatedColumns.put(s[0],s[1]);

		if(dataTodelete!=null)
			for(String s: dataTodelete)
				deletedColumns.add(s);
	}
	
	public Hashtable<String, String> updatedColumns;
	public HashSet<String> deletedColumns;

	
	/**
	 * invoked after checkpoint, the current data is held
	 */
	public void refresh()
	{
		this.deletedColumns.clear();
		this.updatedColumns.clear();
	}
	
//	public String printInfo()
//	{
//		String result="RowData:{\n";
//		String[] keys=rowData.keySet().toArray(new String[rowData.keySet().size()]);
//		for(int i=0;i<keys.length;i++)
//			result+=keys[i]+":" + this.rowData.get(keys[i])+"\n";
//		result+="}\ndeletedColumns:{\n";
//		keys=deletedColumns.toArray(new String[deletedColumns.size()]);
//		for(int i=0;i<keys.length;i++)
//			result+=keys[i]+"\n";
//		result+="}\n";
//		return result;
//	}
	

}
